unit Main;

interface

uses
   Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
   Vcl.Graphics, RVTable, CRVData, RVStyle, RVEdit, RVItem,
   RichView,
   Vcl.Controls, Vcl.Forms, Vcl.Dialogs, RVScroll, SclRView, Vcl.ExtCtrls,
   Vcl.StdCtrls, CRVFData;

type
   rRow = record
      Col: Array of string;
   end;

type
   TfrmMain = class(TForm)
      Panel1: TPanel;
      srve: TSRichViewEdit;
      Button1: TButton;
      Button2: TButton;
      Button3: TButton;
      Button4: TButton;
      procedure Button1Click(Sender: TObject);
      procedure Button2Click(Sender: TObject);
      procedure Button3Click(Sender: TObject);
      procedure FormShow(Sender: TObject);
      private
         { Private declarations }
      public
         { Public declarations }
         procedure AddGrid;

   end;

var
   frmMain: TfrmMain;
   arr: array of rRow;

implementation

{$R *.dfm}

procedure TfrmMain.Button3Click(Sender: TObject);
var
   Item: TCustomRVItemInfo;
   table: TRVTableItemInfo;
   Data: Integer;
   rve: TCustomRichViewEdit;
   ItemNo: Integer;
   RVData: TCustomRVData;
begin
   if not srve.RichViewEdit.GetCurrentItemEx(TRVTableItemInfo, rve, Item) then
      exit;
   table := TRVTableItemInfo(Item);
   ItemNo := rve.GetItemNo(table);
   rve.BeginItemModify(ItemNo, Data);
   table.InsertRowsBelow(1);
   rve.EndItemModify(ItemNo, Data);
   rve.Change;
end;

procedure TfrmMain.Button1Click(Sender: TObject);
begin
   srve.Clear;
   srve.LoadRVF('c:\temp\table.rvf');
   srve.Format;
end;

procedure TfrmMain.FormShow(Sender: TObject);
var
   i, j: Integer;
begin
   // LOAD SOME VALUE TO ARRAY CONTAINER VARS
   setlength(arr, 10);
   for i := 0 to High(arr) do
   begin
      setlength(arr[i].Col, 3);
      for j := 0 to High(arr[i].Col) do
         arr[i].Col[j] := 'Row_' + i.ToString + '/Col_' + j.ToString;
   end;
   Button1.click; // load template
end;

procedure TfrmMain.Button2Click(Sender: TObject);
// var
// ItemNoI, ItemNoF, OffsI, OffsF, dummy: Integer;
begin
   // ItemNoI := 0;
   // ItemNoF := 0;
   // OffsI := 0;
   // OffsF := 0;
   // dummy := -1;
   // while srve.RichViewEdit.SearchTextW('\for_' + 'xx' + '\', [rvseoDown, rvseoMultiItem]) do
   // begin
   // srve.RichViewEdit.TopLevelEditor.GetSelectionBounds(ItemNoI, OffsI, ItemNoF, OffsF, True);
   //
   // AddGrid;
   //
   // srve.RichViewEdit.SetSelectionBounds(ItemNoI, OffsI, ItemNoF, OffsF);
   // srve.RichViewEdit.DeleteSelection;
   // if srve.RichViewEdit.SearchTextW('\end_' + 'xx' + '\', [rvseoDown, rvseoMultiItem]) then
   // srve.RichViewEdit.DeleteSelection;
   // end;

   AddGrid;
end;

procedure TfrmMain.AddGrid;
// function ReplicateRowsInCurrentTable(rve: TCustomRichViewEdit; Count: Integer): Boolean;
// var
// table: TRVTableItemInfo;
// StartRow, i, r, c, RowCount, Data, SourceRow, DestRow: Integer;
// DestCell, SourceCell: TRVTableCellData;
// begin
// Result := rve.GetCurrentItemEx(TRVTableItemInfo, rve, TCustomRVItemInfo(table));
// if not Result then
// exit;
// if table.CanUseHeadingRowCount then
// StartRow := table.HeadingRowCount
// else
// StartRow := 0;
// RowCount := table.RowCount - StartRow;
// Result := RowCount > 0;
// if not Result then
// exit;
// Result := rve.CanChange;
// if not Result then
// exit;
// rve.BeginUndoGroup(rvutModifyItem);
// rve.SetUndoGroupMode(True);
// rve.BeginItemModify(table.GetMyItemNo, Data);
// try
// table.InsertRows(table.RowCount, RowCount * Count, -1, false);
// for i := 0 to Count - 1 do
// for r := 0 to RowCount - 1 do
// begin
// SourceRow := StartRow + r;
// DestRow := StartRow + (i + 1) * RowCount + r;
// for c := 0 to table.ColCount - 1 do
// begin
// SourceCell := table.Cells[SourceRow, c];
// if (SourceCell <> nil) then
// begin
// if (SourceCell.ColSpan > 1) or (SourceCell.RowSpan > 1) then
// table.MergeCells(DestRow, c, SourceCell.ColSpan, SourceCell.RowSpan, false);
// DestCell := table.Cells[DestRow, c];
// DestCell.AssignAttributesFrom(SourceCell, True, 1, 1);
// DestCell.Clear;
// DestCell.AddNL('', SourceCell.GetFirstTextStyleNo(True), SourceCell.GetFirstParaStyleNo);
// end;
// end;
// table.Rows[DestRow].PageBreakBefore := table.Rows[SourceRow].PageBreakBefore;
// table.Rows[DestRow].KeepTogether := table.Rows[SourceRow].KeepTogether;
// table.Rows[DestRow].VAlign := table.Rows[SourceRow].VAlign;
// end;
// table.DeleteEmptyRows;
// table.DeleteEmptyCols;
// finally
// rve.SetUndoGroupMode(false);
// rve.EndItemModify(table.GetMyItemNo, Data);
// rve.Change;
// end;
// end;
//
var
   Item: TCustomRVItemInfo;
   rve: TCustomRichViewEdit;
   table: TRVTableItemInfo;
   ItemNo: Integer;
   RVData: TCustomRVData;
   StartRow, i, r, c, RowCount, Data, SourceRow, DestRow: Integer;
   DestCell, SourceCell: TRVTableCellData;
   function SetCol(r: Integer; s: string): String;
   var
      ps, pe, iCol: Integer;
      str: String;
   begin
      Result := s;
      ps := Pos('{', s);
      pe := Pos('}', s);
      while ps > 0 do
      begin
         if ps = 1 then
         begin
            iCol := Copy(s, ps + 1, pe - ps - 1).ToInteger - 1;
            Result := arr[r].Col[iCol] + Copy(s, pe + 1); // , Length(s)
         end
         else
         begin
            str := Copy(s, 1, ps - 1);
            iCol := Copy(s, ps + 1, pe - ps - 1).ToInteger - 1;
            Result := str + arr[r].Col[iCol] + Copy(s, pe + 1); // , Length(s)
         end;
         ps := Pos('{', Result);
         pe := Pos('}', Result);
      end;
   end;

begin
   RVData := srve.RichViewEdit.RVData;
   ItemNo := -1; // srve.RichViewEdit.GetItemNo(Item);

   if srve.FindNextItem([rvsTable], RVData, ItemNo) then
   begin
      // if ItemNo < 0 then
      // exit;
      table := TRVTableItemInfo(srve.RichViewEdit.GetItem(ItemNo));

      // srve.RichViewEdit.GetCurrentItemEx(TRVTableItemInfo, rve, Item);
      //
      if table.CanUseHeadingRowCount then
         StartRow := table.HeadingRowCount
      else
         StartRow := 0;
      RowCount := table.RowCount - StartRow;
      if RowCount <= 0 then
         exit;
      srve.RichViewEdit.BeginItemModify(table.GetMyItemNo, Data);
      try
         table.InsertRows(table.RowCount, (Length(arr) - 1), 0, false);
         srve.Format;
         // SourceRow := 0; // StartRow + r;
         for r := 0 to Length(arr) - 1 do // RowCount - 1 do
         begin
            // DestRow := r; // StartRow + (i + 1) * RowCount + r;
            for c := 0 to table.ColCount - 1 do
            begin
               if r > 0 then
               begin
                  table.Cells[r, c].Clear;
                  table.Cells[r, c].AssignAttributesFrom(table.Cells[0, c], True, 1, 1); // := table.Cells[DestRow, c];
                  // table.Cells[r, c].AssignItemsFrom(table.Cells[0, c].GetRVData);
               end;
            end;
            table.Rows[r].PageBreakBefore := table.Rows[0].PageBreakBefore;
            table.Rows[r].KeepTogether := table.Rows[0].KeepTogether;
            table.Rows[r].VAlign := table.Rows[0].VAlign;
         end;

         /// / populate cells with Vars and text FROM THE FIRST ROW
         for r := 1 to table.RowCount - 1 do
         begin
            for c := 0 to table.ColCount - 1 do
            begin
               for i := 0 to table.Cells[0, c].ItemCount - 1 do
               begin
                  // table.Cells[r, c].clear ;
                  table.Cells[r, c].AddItemAsIs(table.Cells[0, c].GetItemText(i), table.Cells[0, c].GetItem(i));
                  // table.Cells[r, c].AddItem(table.Cells[0, c].GetItemText(i), table.Cells[0, c].GetItem(i));
                  // table.Cells[r, c].AddNL('aaa',table.Cells[0, c].GetItemStyle(i), table.Cells[0, c].GetRVData.GetItemPara(i));
               end;
            end;
         end;
         srve.Format;
         // Add Value in Vars in each Cells, BUT ALL CELLS HAVE VALUE OF FIRST ROW
         for r := 0 to table.RowCount - 1 do
         begin
            for c := 0 to table.ColCount - 1 do
            begin
               for i := 0 to table.Cells[r, c].ItemCount - 1 do
               begin
                  if Pos('{', table.Cells[r, c].GetItemText(i)) > 0 then
                     table.Cells[r, c].SetItemText(i, SetCol(r, table.Cells[r, c].GetItemText(i)));
               end;
            end;
         end;

         // table.DeleteEmptyRows;
         // table.DeleteEmptyCols;
      finally
         srve.RichViewEdit.EndItemModify(table.GetMyItemNo, Data);
         srve.RichViewEdit.Change;
         srve.Format;
      end;
   end;
end;

end.
